#include <SPI.h>
#define SS_pin P2_5              //Slave select pin

const byte digit [10] = {        
 //Definitions of the 7-bit values for displaying digits
 //This version uses a little bit strange
 //bit order: gfabpcde instead of abcdefgp
            0b01110111,       //0b11111100 (0)
            0b00010100,       //0b01100000 (1)
            0b10110011,       //0b11011010 (2)
            0b10110110,       //0b11110010 (3)
            0b11010100,       //0b01100110 (4)
            0b11100110,       //0b10110110 (5)
            0b11100111,       //0b10111110 (6)
            0b00110100,       //0b11100000 (7)
            0b11110111,       //0b11111110 (8)
            0b11110110};      //0b11110110 (9)
                    
void displayNumber(byte data) {
  byte data1 = ~digit[data /10];  //Bits are complemented for common anode LED display
  byte data0 = ~digit[data % 10]; //Remove tilde character in case of common cathode LED display
  byte IC1bits = data1&0xF0 | data0>>4;
  byte IC2bits = data1&0x0F | data0<<4;
  digitalWrite(SS_pin,LOW);
  SPI.transfer(IC2bits);
  SPI.transfer(IC1bits); 
  digitalWrite(SS_pin,HIGH);
}  

void setup() {
  analogReference(INTERNAL2V5);  // Use the 2,5 V inner reference     
  pinMode(SS_pin,OUTPUT);        //Initialize SS_pin
  SPI.begin();                   //Initialize SPI hardware
  SPI.setBitOrder(LSBFIRST);     //Send least significant bit first  
}

void loop() {
  long  mysum = 0;
  for(int i=0; i<2500; i++) {
    mysum += analogRead (A4);
  }
  // Calculate voltage in mV units
  long voltage = mysum>>10;      //divide by 1024
  long tempC = (voltage-500)/10; //convert to Celsius      
  displayNumber((byte)tempC);     //Display result
  delay(1000);
}
