#include <SPI.h>
#define SS_pin P2_5              //Slave select pin
byte n;
const byte digit [10] = {        // Definitions of the 7-bit values for displaying digits
                    0b11111100,
                    0b01100000,
                    0b11011010,
                    0b11110010,
                    0b01100110,
                    0b10110110,
                    0b10111110,
                    0b11100000,
                    0b11111110,
                    0b11110110 };
                    
void displayNumber(byte data) {
  byte data1 = ~digit[data /10];
  byte data0 = ~digit[data % 10];
  digitalWrite(SS_pin,LOW);
  SPI.transfer(data0);
  SPI.transfer(data1); 
  digitalWrite(SS_pin,HIGH);
}  

void setup() {
  analogReference(INTERNAL2V5);  // Use the 2,5 V inner reference   
  pinMode(SS_pin,OUTPUT);        //Initialize SS_pin
  SPI.begin();                   //Initialize SPI hardware
  SPI.setBitOrder(LSBFIRST);     //Send least significant bit first 
}

void loop() {
  long  mysum = 0;
  for(int i=0; i<2500; i++) {
    mysum += analogRead (A4);
  }
  // Calculate voltage in mV units
  long voltage = mysum>>10;      //divide by 1024
  long tempC = (voltage-500)/10; //convert to Celsius      
  displayNumber((byte)tempC);     //Display result
  delay(1000);
}
